unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  age, height_in_cm, age_limit : integer;
  chr : char;
  i,imax : integer;
  str : string;
  counter : integer;
  year, year_max, month, month_max : integer;

begin

  //if ... then statement
  age:=10;
  if age<12 then begin
     Memo1.Lines.Add('Age: ' + IntToStr(age) + ': You are a child !');
  end;

  //if ... then ... statement variable
  age:=10;
  age_limit:=15;
  if age<age_limit then begin
     Memo1.Lines.Add('Age: ' + IntToStr(age) + ': You are a child !');
  end;

  //if ... then ... else ... statement
  age:=20;
  if age<18 then begin
     Memo1.Lines.Add('Age: ' + IntToStr(age) + ': You are a child !');
  end else begin
      Memo1.Lines.Add('Age: ' + IntToStr(age) + ': You are adult !');
  end;

  //if ... then ... else ... statement with AND
  age:=25;
  height_in_cm:=150;
  if (age>20) and (height_in_cm>140) then begin
     Memo1.Lines.Add('Age: ' + IntToStr(age) +
                     ' ,Height(cm): ' + IntToStr(height_in_cm) +
                     ': You are big person !');
  end else begin
      Memo1.Lines.Add('Age: ' + IntToStr(age) +
                      ' ,Height(cm): ' + IntToStr(height_in_cm) +
                      ': You are a small person !');
  end;

  //if ... then ... else ... statement with OR
  age:=15;
  height_in_cm:=150;
  if (age<20) or (height_in_cm<140)  then begin
     Memo1.Lines.Add('Age: ' + IntToStr(age) +
                     ' ,Height(cm): ' + IntToStr(height_in_cm) +
                     ': You are a small person !');
  end else begin
      Memo1.Lines.Add('Age: ' + IntToStr(age) +
                      ' ,Height(cm): ' + IntToStr(height_in_cm) +
                      ': You are a big person !');
  end;

  //if ... then ... else if ... else ... statements
  age:=21;
  if (age>=0) and (age<=10) then begin
     Memo1.Lines.Add('Age: ' + IntToStr(age) + ': You are between 0-10 years old');
  end else if (age>10) and (age<=20) then begin
      Memo1.Lines.Add('Age: ' + IntToStr(age) + ': You are between 11-20 years old');
  end else if (age>20) and (age<=30) then begin
      Memo1.Lines.Add('Age: ' + IntToStr(age) + ': You are between 21-30 years old');
  end else if (age>30) and (age<=40) then begin
      Memo1.Lines.Add('Age: ' + IntToStr(age) + ': You are between 31-40 years old');
  end else begin
      Memo1.Lines.Add('Age: ' + IntToStr(age) + ': You are 41+ years old');
  end;

  //nested if statements
  age:=21;
  height_in_cm:=200;

  if age>18 then begin

     if height_in_cm<=179 then begin
        Memo1.Lines.Add('Age: ' + IntToStr(age) + ' ,Height(cm): ' + IntToStr(height_in_cm) + ': You are adult and short');
     end else begin // you are taller than 179cm
        Memo1.Lines.Add('Age: ' + IntToStr(age) + ' ,Height(cm): ' + IntToStr(height_in_cm) + ': You are adult and tall')
     end;

  end else begin //age<=18

      Memo1.Lines.Add('Age: ' + IntToStr(age) + ': You are not adult');

  end;


  //case using integer
  age:=35;
  case age  of

       //single value example
       20 : begin //Here you must use constants or hard-coded values -- you cannot use variables.
          Memo1.Lines.Add('Age: ' + IntToStr(age) + ': You are exactly 20');
          Memo1.Lines.Add('-----------------------------------------');
       end;

       //single value example (another)
       21 : begin //Here you must use constants or hard-coded values -- you cannot use variables.
          Memo1.Lines.Add('Age: ' + IntToStr(age) + ': You are exactly 21');
          Memo1.Lines.Add('-----------------------------------------');
       end;

       //multiple 'single' values example
       25,26,27 : begin //Here you must use constants or hard-coded values -- you cannot use variables.
          Memo1.Lines.Add('Age: ' + IntToStr(age) + ': You are between 25 and 27');
          Memo1.Lines.Add('-----------------------------------------');
       end;

       //subrange value example
       30 .. 40 : begin //Here you must use constants or hard-coded values -- you cannot use variables.
          Memo1.Lines.Add('Age: ' + IntToStr(age) + ': You are between 30 and 40');
          Memo1.Lines.Add('-----------------------------------------');
       end;

       //else
       else begin
          Memo1.Lines.Add('Age: ' + IntToStr(age) + ': Unknown age');
          Memo1.Lines.Add('*****************************************');
       end;
  end;  //case


  //case using char
  chr:='g';
  case chr  of

       //single value example
       'a' : begin //Here you must use constants or hard-coded values -- you cannot use variables.
          Memo1.Lines.Add('Char: ' + chr);
          Memo1.Lines.Add('--------------------A-------------------');
       end;

       //single value example (another)
       'b' : begin //Here you must use constants or hard-coded values -- you cannot use variables.
          Memo1.Lines.Add('Char: ' + chr);
          Memo1.Lines.Add('-------------------B----------------------');
       end;

       //multiple 'single' values example
       'c','d','e' : begin //Here you must use constants or hard-coded values -- you cannot use variables.
          Memo1.Lines.Add('Char: ' + chr +  ': char is between c and e');
          Memo1.Lines.Add('-----------------------------------------');
       end;

       //subrange value example
       'f' .. 'j' : begin //Here you must use constants or hard-coded values -- you cannot use variables.
          Memo1.Lines.Add('Char: ' + chr +  ': char is between f and j');
          Memo1.Lines.Add('-----------------------------------------');
       end;

       //else
       else begin
          Memo1.Lines.Add(chr + ': Unknown character');
          Memo1.Lines.Add('*****************************************');
       end;
  end;  //case

  //////////////////////////////
  //////////////////////////////
  //////////////////////////////
  //loops

  //for ... to ... do
  age:=0;
  imax:=9;
  for i:=0 to imax do begin //i is increasing after each loop
      age:=age+1; //increase age
      Memo1.Lines.Add('For Counter i: ' + IntToStr(i) + ' Loop age: ' + IntToStr(age));
  end;

  //for ... downto ... do
  age:=0;
  imax:=9;
  for i:=imax downto 0 do begin //i is decreasing after each loop
      age:=age+1; //increase age
      Memo1.Lines.Add('For downto Counter i: ' + IntToStr(i) + ' Loop age: ' + IntToStr(age));
  end;

  //for ... in ... do ...
  str:='this is a string';
  counter := 0;
  for chr in str do begin //loop char by char the hole string
      if chr='s' then begin
         counter := counter + 1;
      end;
  end;//for
  Memo1.Lines.Add('The string : "' + str +
                  '" contains: ' + IntToStr(counter) +
                  ' times the "s" character');

  //while ... do
  age:=0;
  while age < 6 do begin
        Memo1.Lines.Add('While loop age: ' + IntToStr(age));
        age:=age+1; //increase age
  end;

  //repeat ... until
  age:=0;
  repeat
     Memo1.Lines.Add('While loop age: ' + IntToStr(age));
     age:=age+1; //increase age
  until age = 3;



  //nested loops
  year_max:=3;  //three years
  month_max:=12; //twelve months
  for year:=1 to year_max do begin //for each year
      for month:=1 to month_max do begin  //for each month
          Memo1.Lines.Add('Year :' + IntToStr(year) + ' Month :' + IntToStr(month));
      end;
  end;

  //break example
  age:=0;
  while age < 6 do begin
        Memo1.Lines.Add('While loop age: ' + IntToStr(age));
        age:=age+1; //increase age
        if age >=3 then begin
           break; //when the age reaches
           //3 years break the while loop
        end;
  end;

  //continue
  age:=0;
  while age < 6 do begin
        if age=3 then begin
           age:=age+1; //increase age
           continue; //this does not allow to print the age 3
        end;
        Memo1.Lines.Add('While loop age: ' + IntToStr(age));
        age:=age+1; //increase age
  end;

end;

end.

